

//+------------------------------------------------------------------+
//| trendsignal.mq4
//| contact pankajbhaban@gmail.Com
//+------------------------------------------------------------------+


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Magenta

//---- input parameters
extern string    TimeFrame  = "Current time frame";
extern int RISK=3;
extern int CountBars=350;
extern int Alert_Delay_In_Seconds=0;
extern bool Enablemail = true;
extern string subjectUp="Buy signal";
extern string subjectDown="Sell signal";
extern string textUp="Long ";
extern string textDown="Short ";
int SSP=9;
int PrevAlertTime=0;
//---- buffers
double val1[];
double val2[];
double alertBar;
int      timeFrame;
bool     calculateValue;
bool     returnBars;
string   indicatorFileName;

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
string short_name;
//---- indicator line
IndicatorBuffers(2);
SetIndexStyle(0,DRAW_ARROW);
SetIndexArrow(0,233);
SetIndexStyle(1,DRAW_ARROW);
SetIndexArrow(1,234);
SetIndexBuffer(0,val1);
SetIndexBuffer(1,val2);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
//----
return(0);
}
//+------------------------------------------------------------------+
//| SilverTrend_Signal |
//+------------------------------------------------------------------+
int start()
{
   if (CountBars>=Bars) CountBars=Bars;
      SetIndexDrawBegin(0,Bars-CountBars+SSP);
      SetIndexDrawBegin(1,Bars-CountBars+SSP);
   int i2,K;
   bool uptrend,old;

   if(Bars<=SSP+1) return(0);
   if (calculateValue)
   {
      //---- initial zero
      if(IndicatorCounted()<SSP+1)
      {
         for(int i=1;i<=SSP;i++) val1[CountBars-i]=0.0;
         for(    i=1;i<=SSP;i++) val2[CountBars-i]=0.0;
      }
      //----

      K=33-RISK;
      for (int shift = CountBars-SSP; shift>=0; shift--)
      {
      double Range=0;
      double AvgRange=0;
      for (int i1=shift; i1<=shift+SSP; i1++)
            AvgRange = AvgRange+MathAbs(High[i1]-Low[i1]);
            Range    = AvgRange/(SSP+1);

      double SsMax=High[shift]; 
      double SsMin=Low[shift];
      
      for (i2=shift;i2<=shift+SSP-1;i2++)
      {
         double price=High[i2];  if(SsMax< price) SsMax=price;
                price=Low[i2];   if(SsMin>=price) SsMin=price;
      }

      double smin = SsMin+(SsMax-SsMin)*K/100;
      double smax = SsMax-(SsMax-SsMin)*K/100;
      val1[shift]=0;
      val2[shift]=0;
      
      if (Close[shift]<smin)
      {
         uptrend = false;
      }
      if (Close[shift]>smax)
      {
         uptrend = true;
      }
      if (uptrend!=old && uptrend==true)
      {
         val1[shift]=Low[shift]-Range*0.5;
         if (Bars>alertBar && shift==0 && (CurTime() - PrevAlertTime > Period()*Alert_Delay_In_Seconds))
         {
            Alert(timeFrameToString(Period())+" Trendsignal ",Period()," ",Symbol()," BUY");alertBar = Bars;
            if(Enablemail == true) {SendMail(subjectDown+" "+ Symbol(),textDown+" "+ Close[1]+" "+ Symbol()); 
         }
         PrevAlertTime = CurTime();
      }
      }
      if (uptrend!=old && uptrend==false)
      {
         val2[shift]=High[shift]+Range*0.5;
         if (Bars>alertBar && shift==0 && (CurTime() - PrevAlertTime > Period()*Alert_Delay_In_Seconds))
         {
            Alert(timeFrameToString(Period())+" Trendsignal ",Period()," ",Symbol()," SELL");alertBar = Bars;
            if(Enablemail == true) {SendMail(subjectUp +" "+ Symbol(),textUp+" "+ Close[1]+" " + Symbol());}
            PrevAlertTime = CurTime();
         }
      }
      old=uptrend;
   }
   return(0);
   }

   for (i=MathMin((CountBars-SSP)*timeFrame/Period(),Bars-1); i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+1]);
         if (y!=x)
         {
            val1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RISK,CountBars,Alert_Delay_In_Seconds,Enablemail,subjectUp,subjectDown,textUp,textDown,0,y);
            val2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RISK,CountBars,Alert_Delay_In_Seconds,Enablemail,subjectUp,subjectDown,textUp,textDown,1,y);
         }
         else
         {
            val1[i] = EMPTY_VALUE;
            val2[i] = EMPTY_VALUE;
         }
   }

   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}